apeman-task
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-cmd-labo/apeman-task
[bd_travis_url]: http://travis-ci.org/apeman-cmd-labo/apeman-task
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-cmd-labo/apeman-task.svg?style=flat
[bd_license_url]: https://github.com/apeman-cmd-labo/apeman-task/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-cmd-labo/apeman-task
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-cmd-labo/apeman-task.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-cmd-labo/apeman-task.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-cmd-labo/apeman-task
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-cmd-labo/apeman-task.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-task
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-task.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Task runner for apeman.

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>


Overview
--------

apeman-task helps you to automate development tasks.

Greatly inspired by [grunt][grunt_url], but aimed to have more flexibility.

There are [official task plugins][task_labo_url] supported by apeman team.


[grunt_url]: http://gruntjs.com/
[task_labo_url]: https://github.com/apeman-task-labo

<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>
Installation
-----

```bash
$ npm install apeman-task -g
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>
Usage
---------

1. Prepare an Apemanfile.js at your project root.
2. Run the command via CLI.

**Apemanfile.js**
```javascript
/** Example of Apemanfile.js */

'use strict'

module.exports = {
  $cwd: __dirname,
  $pkg: require('./package.json'),
  $tmpls: { /* ... */ },
  // Define a task
  $tasks: {
    // Use apeman task package
    'my-task01': require('apeman-task-mkdirp')([
      'ci', 'lib', 'test'
    ]),
    // Define a custom task
    'my-task-02' (context) {
      /* ... */
      return new Promise((resolve, reject) => {
        /* ... */
        resolve({})
      })
    },
    // Combine other tasks
    'my-task-03': [
      'my-task01',
      'my-task02'
    ]
  },
  $apps: { /* ... */ },
  $wtchs: { /* ... */ }
}

```

Then,

```bash
$ apeman-task my-task01
```


#### CLI Options

```bash
$ apeman-task -h

  Usage: apeman-task [options] [name...] 

  Run tasks.

  Options:

    -h, --help                           output usage information
    -V, --version                        output the version number
    -s, --silent                         Disable console logs
    -v, --verbose                        Show verbose logs
    -c, --configuration <configuration>  Pathname of Apemanfile

  Examples:

    $ apeman-task                     # Show all available tasks.
    $ apeman-task build test          # Run tasks.


```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Programmatic API.md.hbs" Start -->

<a name="section-doc-guides-03-programmatic-a-p-i-md"></a>
Programmatic API
---

apeman-task also provide programmatic API.

Firstly, install the module locally.

```bash
$ npm install apeman-task --save-dev
```

Then,

```javascript
'use strict'

const apemanTask = require('apeman-task')

apemanTask('my-task02', {
  // Options
}).then(() => {
  /* ... */
})

```


#### Programmatic Options

| Key | Description | Default |
| --- | ----------- | ------- |
| silent | Disable console logs |  |
| verbose | Show verbose logs |  |
| configuration | Pathname of Apemanfile |  |


<!-- Section from "doc/guides/03.Programmatic API.md.hbs" End -->

<!-- Section from "doc/guides/04.Contributing.md.hbs" Start -->

<a name="section-doc-guides-04-contributing-md"></a>
Contribution
------

You can create your own task plugin quickly with scaffold.

Install [apeman-scff][scaffold_url] as a global module

```bash
$ npm install apeman-scff -g
```

then, generate scaffold.

```bash
$ apeman-scff task apeman-task-yourown
```

[scaffold_url]: https://www.npmjs.com/package/apeman-scff


<!-- Section from "doc/guides/04.Contributing.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-cmd-labo/apeman-task/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman](http://github.com/apeman-labo/apeman)
+ [apeman-cmd-labo](https://github.com/apeman-cmd-labo)
+ [apeman-task-labo](https://github.com/apeman-task-labo)

<!-- Links End -->
