/**
 * Test case for apemanTask.
 * Runs with mocha.
 */
'use strict'

const apemanTask = require('../lib/apeman_task.js')
const assert = require('assert')

describe('apeman-task', () => {
  it('List task', (done) => {
    apemanTask({
      configuration: require.resolve('../doc/mocks/mock-Apemanfile.js')
    }).then(
      (result) => done(),
      (err) => assert.ifError(err)
    )
  })

  it('Run task', (done) => {
    apemanTask('foo', {
      configuration: require.resolve('../doc/mocks/mock-Apemanfile.js')
    }).then(
      (result) => done(),
      (err) => assert.ifError(err)
    )
  })

  it('Run child task', (done) => {
    apemanTask('child01#bar', {
      configuration: require.resolve('../doc/mocks/mock-Apemanfile.js')
    }).then(
      (result) => done(),
      (err) => assert.ifError(err)
    )
  })
})

/* global describe, it */
