/**
 * Test case for runTask.
 * Runs with mocha.
 */
'use strict'

const runTask = require('../lib/tasking/run_task.js')
const assert = require('assert')

describe('run task', () => {
  it('Do run.', (done) => {
    runTask({
      get (name) {
        return function (context) {
          return new Promise((resolve, reject) => {
            resolve()
          })
        }
      }
    }, 'foo').then(
      (result) => done(),
      (err) => assert.ifError(err)
    )
  })

  it('Do run nested task.', (done) => {
    runTask.nestedTask({
      get (name) {
        return function task (context) {
          return Promise.resolve({
            fooTask: 'bar'
          })
        }
      }
    }, 'foo').then(
      (result) => done(),
      (err) => assert.ifError(err)
    )
  })
})

/* global describe, before, after, it */
